%%HP: T(3)A(D)F(.);
DIR                                    @ PBAK DIRECTORY VERSION 1.4.
ARCIT                                  @ DO A HOME BACKUP WITH FLAGS.
 \<< GHOSTF                            @ Get/Save host directory string.
     " \<< " RCLF \-> flags            @ RCLF and save to local var.
     \<<
        STD                            @ Set standard diplay mode
        flags \->STR +                 @ Build the FLAGS program
        " STOF 'FLAGS' PURGE \>> " +   @ in string form.
        OBJ\->                         @ Convert the string to a program.
        'FLAGS' STO                    @ STO in 'FLAGS'.
        ":IO:" "MBAK" DATE             @ Build the ARCHIVE destination
        DUP IP \->STR PAD0             @ identifier. ":IO:MBAK" + month
        SWAP FP 100 * IP               @ and day with two digits each.
        \->STR PAD0 + +                @ Store ID without :IO: in
        DUP 'LASTARC' STO              @ PBAKPATH 'LASTARC'.
        flags STOF                     @ restore the flags
     \>>
     IFPCDEL                           @ If on PC delete it
     +                                 @ Make full ID.
     OBJ\->                            @ Convert string to an IO object.
     ARCHIVE                           @ Do the memory archive.
     PBAKPATH EVAL                     @ Return to PBAK directory.
 \>>
ARCM                                   @ DO A HOME BACKUP ONLY.
 \<< 'CONTM'                           @ Put name of CONT program on
     ARCSTART                          @ the stack and do setup.
     { PBAKPATH CONTM LIB1222 } 'FLAGS'@ Put list of cleanup vars on stack.
     ARCEND                            @ Do the ARCHIVE and finish up.
 \>>
ARC0                                   @ DO A PORT 0 AND HOME BACKUP.
 \<< 'CONT?'                           @ Put name of CONT program on
     ARCSTART                          @ the stack and do setup.
     P0\->                             @ Archive Port 0.
     { PBAKPATH CONT? LIB1222 } 'FLAGS'@ Put list of cleanup vars on stack.
     ARCEND                            @ Do the ARCHIVE and finish up.
 \>>
ARC?                                   @ DO AN ALL PORT AND HOME BACKUP.
 \<< 'CONT?'                           @ Put name of CONT program on
     ARCSTART                          @ the stack and do setup.
     P?\->                             @ Archive Port 0.
     { PBAKPATH CONT? LIB1222 } 'FLAGS'@ Put list of cleanup vars on stack.
     ARCEND                            @ Do the ARCHIVE and finish up.
 \>>
ARCSTART
 \<< PHOSTF                            @ Make sure no old PC dir. still here.
     PATHSAVE                          @ Save PBAK path.
     DUP RCL SWAP HOME                 @ RCL CONT program and go home HOME.
     0 PVARS DROP                      @ Get port 0 list.
     IF :0: 1222 POS THEN              @ If STOFIX is loaded (Rev M CRAP)
       :0: 1222 RCL                    @ Get it and
       'LIB1222' STO                   @ save it in HOME.
     END
     STO                               @ STO the CONT program.
     PBAKPATH EVAL                     @ Return to the PBAK directory.
     GHOSTF                            @ Get/Save host directory string.
 \>>
ARCEND                                 @ DO AN ALL PORT AND HOME BACKUP.
 \<< ARCIT                             @ ARCHIVE mem.
     RSTFILE                           @ Send the restore file.
     PURGE                             @ Purge RSTOPBAK
     PHOSTF                            @ Purge the HOSTLISTS.
     HOME PURGE 2 MENU                 @ Go HOME and Clean up.
     "MEMORY ARCHIVING"                @ Tell the world we're done.
     "COMPLETED"
 \>>
CONTM                                  @ HOME ONLY CONTINUE AFTER RESTORE
 \<< { CONTM LIB1222 } PURGE           @ Deletes itself and LIB1222 if present.
     PBAKPATH EVAL                     @ Go to PBAK Directory
     FLAGS                             @ Restore all flags.
     HOME 'PBAKPATH' PURGE             @ Clean up HOME
 \>>
CONT?                                  @ PORT/HOME CONTINUE AFTER RESTORE
 \<< "\<< PBAKPATH EVAL FLAGS \->P
      HOME { PBAKPATH CONT? }
      PURGE \>>"                       @ New CONT? to replace archived one.
      OBJ\->                           @ Convert to a program
      'CONT?' STO                      @ Overwrite CONT?.
     VARS 'LIB1222'
     IF POS THEN                       @ If a copy of STOFIX in HOME.
       LIB1222 'LIB1222' PURGE         @ Put it on the stack and PURGE VAR.
       0 PVARS DROP                    @ Get list of stuff in port 0.
       IF :0: 1222 POS NOT THEN        @ If STOFIX isn't loaded
         0 STO                         @ then RCL LIB1222 and STO it.
         OFF                           @ YOU NEED TO TURN HP48 BACK ON!!!
       ELSE
         DROP                          @ Drop Stofix from the stack.
       END                             @ Then press CONT? again.
     END
     CONT?                             @ If Stofix not needed finish up.
 \>>
CST                                    @ CUSTOM MENU.
 { ARCM ARC0 ARC? P0\-> P?\-> PSEND
   { FULL \<< 1 'FULLBAK' STO \>> }
   { NEW \<< 0 'FULLBAK' STO \>> }
   { } \->P  { } QUIT
 }
IFPCDEL                                @ IF FILE IS ON THE PC DELETE IT
 \<< DUP IF DUP TYPE 2 \=/ THEN        @ If this is a name not a string then
       # 5BE9h SYSEVAL                 @ convert the name to a string.
     END
     DUP HOSTFILES SWAP                @ Check to see if the object is
     IF POS THEN                       @ is already archived. If it is
       "DEL " SWAP + "C"               @ Make the remote host delete command
       PKT                             @ then send it.
     ELSE                              @ If no file with this name then
       DROP                            @ Clean up.
     END
 \>>
FULLBAK                                @ BACKUP OPTION FLAG
 0                                     @ 1=FULL 0=NEW OBJECTS ONLY
GHOSTF                                 @ GET THE HOST FILE STRING
 \<< IF VARS 'HOSTFILES' POS NOT THEN  @ If no PC vars string get it.
       "D" "G" PKT                     @ Get host directory string.
       'HOSTFILES' STO                 @ Save it for reference.
     END
 \>>
LASTARC                                @ Name of the last memory archive.
 "MBAK0219"
LIBSLIST                               @ PORT OBJECT REFERENCE LIST.
 { :0: 1101 :0: 874 :0: 1352 :0: 1786  @ Created by LSTSTO.
   :0: 962 :0: 804 :0: 805 :0: 1001    @ Two lines of libs in port 0.
   :0: THISISOK                        @ A named object in port 0.
   :1: SOISTHIS.1                      @ A named object in port 1.
   :2: 123WHATE.VER                    @ A named object in port 2.
   :0: AN?ILLEGAL?DOS?FILENAME         @ ERROR! Won't be PBAK restorable!
   :7: MBAK0216                        @ A named backup object in port 7
 }                                     @ for wealthy GX owners only :-(.
LSTSTO                                 @ MAKE LIBSLIST FROM LIST.
 \<< IF DUP :0: 1222 POS THEN          @ If STOFIX is loaded (Rev M CRAP)
       DUP :0: 1222 POS \-> pos        @ Save its position
         \<< OBJ\-> \-> tot            @ OBJ-> and save the depth.
           \<< IF pos tot \=/ THEN     @ If STOFIX not at stack1
                 tot pos 1 - - ROLL    @ move it to stack1.
               END
               DROP tot 1 - \->LIST    @ Trash STOFIX ID and rebuild
           \>>                         @ the list.
         \>>
     END
     DUP 'LIBSLIST' STO                @ STO the list in LIBSLIST and
 \>>                                   @ leave the list on the stack.
MK?LST                                 @ MAKE AN OBJECT LIST FOR ALL PORTS
 \<< P?LST LSTSTO  \>>                 @ Get list and call LSTSTO.
MK0LST                                 @ MAKE AN OBJECT LIST FOR PORT 0
 \<< 0 PVARS DROP LSTSTO \>>           @ and call LSTSTO.
PAD0                                   @ ADDS LEAD "0" TO DATE FIELDS
 \<< DUP SIZE                          @ Size the date field
     IF 1 ==                           @ If only 1 character
     THEN
       "0" SWAP +                      @ pad with a leading "0".
     END
 \>>
P0\->                                  @ BACKUP PORT 0.
    \<< MK0LST PSEND \>>               @ Make port 0 list ans send.
P?LST                                  @ MAKE A LIST FOR ALL PORTS.
 \<< ERR0 -1 0 \-> port error          @ Clear ERR, port = -1, error = 0.
    \<< DO                             @ Loop through ports until ERR.
          'port' INCR                  @ Increment port counter.
           IFERR                       @ Trap errors.
             PVARS                     @ Get a port object list.
             IF TYPE NOT THEN          @ If a size is on the stack
               IF port 0 > THEN        @ and this is not port 0
                 +                     @ add the lists.
               END
             ELSE                      @ If not a size (SYSRAM, etc.)
               DROP                    @ Take out the trash.
             END
           THEN                        @ If a PVARS error
             IF port 1 > THEN          @ and this is port 2 or higher
               'error' INCR            @ set the error flag.
             ELSE                      @ If error on port 1
               DROP                    @ Take out the trash
             END                       @ but keep on going.
             ERR0                      @ Clear ERR
           END
        UNTIL error                    @ Exit on error.
        END
        2 DROPN                        @ Clean up the stack.
    \>>
 \>>
P?\->                                  @ ARCHIVE ALL PORTS.
 \<<  MK?LST PSEND \>>                 @ Make all port list and send.
PATHSAVE                               @ SAVE THE PBAK PATH IN HOME
 \<< PATH HOME 'PBAKPATH' STO          @ Get path, go home and save it
     PBAKPATH EVAL                     @ then go back to PBAK.
 \>>
PHOSTF                                 @ GET THE HOST FILE STRING
 \<< IF VARS 'HOSTFILES' POS THEN      @ If PC vars string is here
       'HOSTFILES' PURGE               @ then PURGE the HOSTLIST.
     END
 \>>
PSEND                                  @ TAKE LIST FROM STACK AND SEND
 \<< GHOSTF                            @ Get/Save host directory string.
     DUP SIZE 1 SWAP                   @ Set FOR start end (1 to list size).
     RCLF \-> flags                    @ Recall and hold flgas for later.
     \<<
        STD                            @ Set satndard diplay mode.
        FOR i DUP i                    @ FOR each object in the list.
          GET                          @ Get the object.
            DUP RCL SWAP
            OBJ\-> DROP DUP            @ Pull out name or lib number.
            IF TYPE NOT THEN           @ If it's a lib number.
              \->STR "LIB" SWAP +      @ Convert to "LIB" + "LIB#".
            ELSE                       @ If it's a name then
              # 5BE9h SYSEVAL          @ Convert the name to a string.
            END
            IF FULLBAK THEN            @ If a FULL backup is selected
              IFPCDEL
              # 5B15h SYSEVAL          @ Convert string to a name.
              DUP 3 ROLLD STO          @ STO object.
              DUP SEND                 @ SEND object to the PC.
              PURGE                    @ PURGE the object.
            ELSE                       @ If a NEW backup is selected then
              DUP HOSTFILES SWAP       @ Check to see if the object is
              IF POS NOT THEN          @ is already archived. If NOT do it.
                # 5B15h SYSEVAL        @ Convert string to a name.
                DUP 3 ROLLD STO        @ STO object.
                DUP SEND               @ SEND object to the PC.
                PURGE                  @ PURGE the object.
              ELSE                     @ If it's already there then
                2 DROPN                @ trash it.
              END
            END
        NEXT                           @ Do it again.
        flags STOF                     @ Restore all flags.
     \>>
     DROP                              @ All done so trash the list.
     PHOSTF                            @ Purge the HOSTLIST.
     "PORT(S) ARCHIVING"               @ Tell the world we're done.
     "COMPLETED"
 \>>
QUIT                                   @ We're outa' here!
 \<< UPDIR \>>
\->P                                   @ RESTORE ALL PORTS.
 \<< GHOSTF                            @ Get/Save host directory string.
     0 PVARS DROP                      @ Get port 0 object list.
     :0: 1222 POS                      @ Is STOFIX loaded? (Rev. M CRAP)
     RCLF
     \-> stofix flags                  @ STOFIX flag.
       \<<
           STD                         @ Set standard display mode.
           LIBSLIST                    @ Get the object list.
           DUP SIZE 1 SWAP             @ Set FOR start end (1 to list size).
           FOR i DUP i                 @ FOR each object in the list.
             GET                       @ GET the object ID.
             \-> portid                @ object ID variable
             \<<
               portid OBJ\->           @ Get the object ID drop the port.
               OBJ\-> PVARS DROP       @ Get objects already in this port.
               IF portid POS NOT THEN  @ If not already there keep going.
                 IF DUP TYPE NOT THEN  @ If this a library
                   \->STR "LIB" SWAP + @ Convert to "LIB" + "LIB#".
                 END
                 DUP HOSTFILES SWAP    @ If the object is is on the PC
                 IF POS THEN           @ keep on going.
                   # 5B15h SYSEVAL     @ Convert string to a name.
                   DUP DUP KGET        @ KGET the object.
                   RCL                 @ RCL the object.
                   SWAP PURGE          @ PURGE from PBAK.
                   portid              @ Put portid on stack.
                   IF stofix THEN      @ If STOFOX is loaded.
                     sto               @ Use it.
                   ELSE                @ If not.
                     STO               @ Use the STO key.
                   END
                 ELSE                  @ If object wasn't on the PC
                   " NOT FOUND"        @ leave a message on the stack.
                   + SWAP
                 END
               ELSE                    @ If it's already in memory
                 DROP                  @ trash it.
               END
             \>>
          NEXT                         @ Do it again.
          DROP                         @ All done so trash the list.
          flags STOF
       \>>
    PHOSTF
    "TURN HP48 OFF AND"                @ Tell the world what to do.
    "BACK ON TO ATTACH"
    "ALL THE LIBRARIES"
 \>>
RSTFILE                                @ RSTOPBAK PROGRAM BUILDER
 \<< " \<< 'RSTOPBAK' PURGE "          @ Programs Deletes itself
     LASTARC +                         @ Puts archive filename on stack.
     " \-> file
       \<< file KGET file RCL
           file PURGE RESTORE
       \>>" +                          @ Transfer/RCL/PURGE/RESTORE.
     " \>>" + OBJ\->                   @ Convert string to program.
     'RSTOPBAK' STO                    @ STO the program.
     'RSTOPBAK'
     IFPCDEL
     DUP SEND PURGE                    @ SEND it then PURGE it.
 \>>
END                                    @ Th-Th-Th-Th-That's all folks!
